#version 120

#define TAA

uniform float rainStrength;
uniform float frameTimeCounter;

uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

varying vec2 texcoord;
varying vec2 lmcoord;
varying vec4 color;

varying vec3 normal;
varying vec3 viewVector;

varying mat3 tbn;

uniform int frameCounter;

uniform float viewWidth;
uniform float viewHeight;

attribute vec4 at_tangent;
attribute vec4 mc_Entity;

varying float id;

vec2 jitter[8] = vec2[8](vec2( 0.125,-0.375),
							   vec2(-0.125, 0.375),
							   vec2( 0.625, 0.125),
							   vec2( 0.375,-0.625),
							   vec2(-0.625, 0.625),
							   vec2(-0.875,-0.125),
							   vec2( 0.375,-0.875),
							   vec2( 0.875, 0.875));
				

vec2 taaJitter(vec2 coord, float w){
	return jitter[int(mod(frameCounter,8.0))]*(w/vec2(viewWidth,viewHeight)) + coord;
}
void main() {
    vec4 pos = gl_Vertex;
	
	if(mc_Entity.x == 161.0 || mc_Entity.x == 18.0 || mc_Entity.x == 175.0 || mc_Entity.x == 32.0 || mc_Entity.x == 31.0 || mc_Entity.x == 8.0 || mc_Entity.x == 9.0) {
		pos.y += 0.1 * sin((frameTimeCounter*1.2+(5.2*rainStrength)) + pos.x + pos.z);
	}
	
    gl_Position = gl_ProjectionMatrix * (gl_ModelViewMatrix * pos);
    #ifdef TAA
    gl_Position.xy = taaJitter(gl_Position.xy, gl_Position.w);
    #endif
    
    texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;

    lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
    
    color = gl_Color;

    normal 	= normalize(gl_NormalMatrix*gl_Normal);
        vec3 tangent = normalize(gl_NormalMatrix*at_tangent.xyz);
        vec3 binormal = normalize(gl_NormalMatrix*cross(at_tangent.xyz, gl_Normal.xyz) * at_tangent.w);

        tbn     = mat3(tangent.x, binormal.x, normal.x,
                    tangent.y, binormal.y, normal.y,
                    tangent.z, binormal.z, normal.z);
    id = mc_Entity.x;

	viewVector = tbn*normalize(gl_ModelViewMatrix * gl_Vertex).xyz;

}